SystemOrganization addCategory: #'SCouchDB-Application-Evently-Core'!

JsonObject subclass: #SCEvently
	instanceVariableNames: 'events triggers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

SCEvently subclass: #EventlyAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/15/2013 13:14'!
initialize:size
super initialize:size.

self renderAccountEventOn:self.
self renderLoggedinEventOn: self.
self renderLoggedoutEventOn: self.
self renderLoginFormEventOn:self.
self renderSignUnFormEventOn:self.
self renderItemsEventOn:self.
self renderProfileEventOn:self
! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:29'!
renderAccountEventOn:evently

(evently at:'account')  onEvent:'_init' do:
'function() {
  var elem = $(this);
  $$(this).userCtx = null;
  $.couch.session({
    success : function(r) {
      var userCtx = r.userCtx;
      if (userCtx.name) {
        elem.trigger("loggedIn", [r]);
      } else if (userCtx.roles.indexOf("_admin") !!= -1) {
        elem.trigger("adminParty");
      } else {
        elem.trigger("loggedOut");
      };
    }
  });
}' ;
onEvent:'adminParty' mustache:
'<p><strong>Admin party, everyone is admin!!</strong> Fix this in <a href="/_utils/index.html">Futon</a> before proceeding.</p>';

onEvent:'doLogin' do:
'function(e, name, pass) {
  var elem = $(this);
  $.couch.login({
    name : name,
    password : pass,
    success : function(r) {
      elem.trigger("_init")
    }
  });      
}';
onEvent:'doLogout' do:
'function() {
  var elem = $(this);
  $.couch.logout({
    success : function() {
      elem.trigger("_init");
    }
  });
}';
onEvent:'doSignup' do:
'function(e, name, pass) {
  var elem = $(this);
  $.couch.signup({
    name : name
  }, pass, {
    success : function() {
      elem.trigger("doLogin", [name, pass]);
    }
  });
}'.! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:29'!
renderItemsEventOn:evently
((evently at:'items' onEvent:'_changes') 
data:'function(data) {
  // $.log(data)
  var p;
  return {
    items : data.rows.map(function(r) {
      p = (r.value && r.value.profile) || {};
      p.message = r.value && r.value.message;
      return p;
    })
  }
};'
mustache:'<p>Customize this format here: <tt>ddoc.evently.items._changes.mustache</tt></p>
<h3>Recent Messages</h3>
<ul>
  {{#items}}
    <li>
      <div class="avatar">
        {{#gravatar_url}}<img src="{{gravatar_url}}" alt="{{name}}"/>{{/gravatar_url}}
        <div class="name">
          {{nickname}}
        </div>
      </div>
      <p>{{message}}</p>
      <div style="clear:left;"></div>
    </li>
  {{/items}}
</ul>
<p><em>Protip:</em> If you setup continuous replication between this database and a remote one, this list will reflect remote changes in near real-time.</p>
<p>This would be a good place to add pagination.</p>')

query view:'recent-items'; descending: true;limit: 50.! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:15'!
renderLoggedinEventOn: evently
(evently at:'account' onEvent:'loggedIn')
selector: 'a[href=#logout]' 
onClick:(Array with:'doLogout') ;
data:'function(e, r) {
  return {
    name : r.userCtx.name,
    uri_name : encodeURIComponent(r.userCtx.name),
    auth_db : encodeURIComponent(r.info.authentication_db)
  };
}'
mustache:'<span>Welcome 
<a target="_new" href="/_utils/document.html?{{auth_db}}/org.couchdb.user%3A{{uri_name}}">{{name}}</a>!! 
<a href="#logout">Logout?</a>
</span>';
onEvent:'after' do:'function(e, r) {
  $$(this).userCtx = r.userCtx;
  $$(this).info = r.info;
};'.
! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/12/2012 18:01'!
renderLoggedoutEventOn: evently
(evently at:'account' onEvent:'loggedOut')
mustache: '<a href="#signup">Signup</a> or <a href="#login">Login</a>';
selector: 'a[href=#signup]' onClick:(Array with:'signupForm');
selector: 'a[href=#login]' onClick:(Array with:'loginForm').

! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/12/2012 18:01'!
renderLoginFormEventOn: evently
(evently at:'account' onEvent:'loginForm')
selector: 'a[href=#signup]' onClick:(Array with:'signupForm');
selector: 'form' onSubmit:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doLogin'', [name, pass]);
  		return false;
	}';
mustache:'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Login">
  <a href="#signup">or Signup</a>
</form>';
onEvent:'after' do:'function() {
  $("input[name=name]", this).focus();
}'.

! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:18'!
renderProfileEventOn:evently
((evently at:'profile') onEvent:'loggedIn' do:'function(e, r) {
  	var userCtx = r.userCtx;
  	var widget = $(this);
  	// load the profile from the user doc
  	var db = $.couch.db(r.info.authentication_db);
  	var userDocId = "org.couchdb.user:"+userCtx.name;
  	db.openDoc(userDocId, {
    		success : function(userDoc) {
      		var profile = userDoc["couch.app.profile"];
      		if (profile) {
        		// we copy the name to the profile so it can be used later
        		// without publishing the entire userdoc (roles, pass, etc)
        		profile.name = userDoc.name;
        		$$(widget).profile = profile;
        		widget.trigger("profileReady", [profile]);
      		} else {
        		widget.trigger("noProfile", [userCtx]);
      	}
    	}
  });
}';
onEvent:'loggedOut' mustache:'<p>Please log in to see your profile.</p>')
	onEvent:'after' do:'function() {  $$(this).profile = null;};'.

((evently at:'profile' onEvent:'noProfile')
data:'function(e, userCtx) {
  return userCtx;
}'
mustache:'<form>
  <p>Hello {{name}}, Please setup your user profile.</p>
  <label for="nickname">Nickname 
    <input type="text" name="nickname" value=""></label>
  <label for="email">Email (<em>for <a href="http://gravatar.com">Gravatar</a></em>)
    <input type="text" name="email" value=""></label>
  <label for="url">URL 
    <input type="text" name="url" value=""></label>
  <input type="submit" value="Go &rarr;">
  <input type="hidden" name="userCtxName" value="{{name}}" id="userCtxName">
</form>';
onEvent:'_init')
selector: 'form' onSubmit:'function() {
  var md5 = $$(this).app.require("vendor/couchapp/lib/md5");
  
  // TODO this can be cleaned up with docForm?
  // it still needs the workflow to edit an existing profile
  var name = $("input[name=userCtxName]",this).val();
  var newProfile = {
    rand : Math.random().toString(), 
    nickname : $("input[name=nickname]",this).val(),
    email : $("input[name=email]",this).val(),
    url : $("input[name=url]",this).val()
  }, widget = $(this);

  // setup gravatar_url
  if (md5) {
    newProfile.gravatar_url = ''http://www.gravatar.com/avatar/''+md5.hex(newProfile.email || newProfile.rand)+''.jpg?s=40&d=identicon'';    
  }

  // store the user profile on the user account document
  $.couch.userDb(function(db) {
    var userDocId = "org.couchdb.user:"+name;
    db.openDoc(userDocId, {
      success : function(userDoc) {
        userDoc["couch.app.profile"] = newProfile;
        db.saveDoc(userDoc, {
          success : function() {
            newProfile.name = userDoc.name;
            $$(widget).profile = newProfile;
            widget.trigger("profileReady", [newProfile]);
          }
        });
      }
    });
  });
  return false;
}'.


(((evently at:'profile' onEvent:'profileReady')
data:'function(e, p) {
  return p
}
'
mustache:'<div class="avatar">
  {{#gravatar_url}}<img src="{{gravatar_url}}"/>{{/gravatar_url}}
  <div class="name">
    {{nickname}}
  </div>
</div>
<p>Hello {{nickname}}!!</p>
<div style="clear:left;"></div>') 
onEvent:'_init') 
selector: 'form' 
onSubmit: 'function() {
  var form = $(this);
  var fdoc = form.serializeObject();
  fdoc.created_at = new Date();
  fdoc.profile = $$("#profile").profile;
  $$(this).app.db.saveDoc(fdoc, {
    success : function() {
      form[0].reset();
    }
  });
  return false;
};'; onEvent:'after' do:'function(e, p) {
  $$(this).profile = p;
};'


! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:05'!
renderSignUnFormEventOn: evently
(evently at:'account' onEvent:'signupForm')
selector: 'a[href=#login]' onClick:(Array with:'loginForm');
selector: 'form' onSubmit:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doSignup'', [name, pass]);
  		return false;
	}';
mustache:'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Signup">
  <a href="#login">or Login</a>
</form>';
onEvent:'after' do:'function() {
  $("input[name=name]", this).focus();
}'
! !

!SCEvently methodsFor: 'private' stamp: 'JesusMari 8/16/2013 09:58'!
addTriggersFromJSCode:eventlyEvent
| i j k eventName|

i:=1.j:=1.k:=1.eventName=''.
[i = 0] whileFalse:[
	i:= eventlyEvent findString:'.trigger' startingAt:i. 
	(i>0) ifTrue:[
		i:= eventlyEvent findString: '(' startingAt: i.
		j:= eventlyEvent findString: ')' startingAt: i.
	
		eventName:=(eventlyEvent copyFrom:i to: j) withBlanksTrimmed.
		eventName:=eventName copyFrom:2 to:(eventName size -1). 
		k:= eventName findString:','.
		(k=0 and:[(i ~= 0 and:[j~=0])]) ifTrue: [eventName:= (eventName copyFrom:2 to:(eventName size -1))].
		(k>0 and:[(i ~= 0 and:[j~=0])]) ifTrue: [eventName:= (eventName copyFrom:2 to:(k -2))]].
		(eventName notNil and:[eventName size>1 and:[(eventName at:1) ~=$_]]) ifTrue:[self triggers add:eventName]
].
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:59'!
at:anEventlyName
^super at:(anEventlyName) ifAbsent:[
	self at:(anEventlyName) put:SCEvently new] ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:55'!
at:anEventlyName onEvent:anEvent
| e |
e:=self at:(anEventlyName).
^e onEvent:anEvent! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:56'!
at:anEventlyName onEvent:anEvent data:aDataString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:56'!
at:anEventlyName onEvent:anEvent data:aDataString mustache:aMustacheString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e

! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 8/15/2013 14:08'!
at:anEventlyName onEvent:anEvent do:anObject
| e |
e:=self at:(anEventlyName).
^e onEvent:anEvent do:anObject! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:57'!
at:anEventlyName onEvent:anEvent mustache:aMustacheString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:58'!
at:anEventlyName onEvent:anEvent  mustache:aMustacheString data:aDataString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:59'!
at:anEventlyName onEvent:anEvent selector:aJQuerySelector
| e |
e:=self at:(anEventlyName).
^(e onEvent:anEvent ) selector:aJQuerySelector! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/1/2012 12:34'!
data: aStringData
self at:'data' put:aStringData! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/16/2012 00:15'!
data: aStringData mustache:aMustacheTemplate
self data:aStringData.
self mustache:aMustacheTemplate! !

!SCEvently methodsFor: 'private' stamp: 'JesusMari 8/15/2013 13:55'!
events
^events ! !

!SCEvently methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/15/2013 10:23'!
initialize: size
super initialize:size.
events := OrderedCollection new.
triggers:= OrderedCollection new.! !

!SCEvently methodsFor: 'protected' stamp: 'JesusMari 8/15/2013 11:45'!
isAJQueryEventListener

(self triggers isEmpty) ifFalse:[^true].
self values do:[:aSCEvenlyObject|
		(aSCEvenlyObject isAJQueryEventListener) ifTrue:[^true]
		].
^false
 
! !

!SCEvently methodsFor: 'protected' stamp: 'JesusMari 8/18/2013 19:56'!
listeningAt:anEventlyNode
|la at en |

"get triggers"
en :=Set new.
la:= Set new.
at:=(self at:anEventlyNode) triggering. 
self keys do:[:aNode|
	la addAll: (at select:[:aE| aNode~=anEventlyNode and:[(self at:aNode) listeningTo includes: aE]]).
	la size>0 ifTrue:[en add:(Array with:aNode with:la asArray)]
	].
^en asArray! !

!SCEvently methodsFor: 'protected' stamp: 'JesusMari 8/15/2013 13:57'!
listeningTo
|oc|
oc:=OrderedCollection new.
oc addAll: self events.
self values do:[:anEvenlyObject|
	(anEvenlyObject isKindOf:SCEvently) ifTrue: 
		[oc addAll: anEvenlyObject events]].
^oc asArray
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/1/2012 22:52'!
mustache: aMustacheTemplate
(aMustacheTemplate isKindOf:MustacheTemplate)
ifTrue:[self at:'mustache' put: aMustacheTemplate render]
ifFalse:[self at:'mustache' put: aMustacheTemplate asString]! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/16/2012 00:15'!
mustache:aMustacheTemplate data: aStringData 
self data:aStringData.
self mustache:aMustacheTemplate! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 8/16/2013 10:04'!
onEvent:anEventlyEvent
((anEventlyEvent at:1 )~=$_) ifTrue:[self events add:anEventlyEvent].
^self at:anEventlyEvent ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:30'!
onEvent:anEvent data:aDataString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:30'!
onEvent:anEvent data:aDataString mustache:aMustacheString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e

! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 8/18/2013 19:49'!
onEvent:anEvent do:anObject
anObject isArray ifTrue:[triggers addAll: anObject ]
	ifFalse:[self addTriggersFromJSCode:anObject].
	((anEvent at:1 )~=$_) ifTrue:[self events add:anEvent].
self at:anEvent put:anObject.
^self at:anEvent ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:31'!
onEvent:anEvent mustache:aMustacheString
| e |
e:=self  onEvent:anEvent.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:31'!
onEvent:anEvent  mustache:aMustacheString data:aDataString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:35'!
onEvent:anEvent selector:aJQuerySelector
| e |

^(self onEvent:anEvent ) selector:aJQuerySelector! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/17/2012 01:01'!
query
^ self at:'query' ifAbsent:[self at:'query' put:SCEventlyQuery new]! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/17/2012 01:00'!
selector:aSelector
^self selectors at:aSelector ifAbsent:[self selectors at:aSelector put:SCEventlySelector new]! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector:aSelector onBlur: eventHandler
self selector:aSelector  onEvent:'blur' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector: aSelector onChange: eventHandler
self selector:aSelector  onEvent:'change' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:25'!
selector:aSelector onClick: eventHandler
self selector:aSelector onEvent:'click' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:22'!
selector:aSelector onDblClick: eventHandler
self selector:aSelector onEvent:'dblclick' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:13'!
selector: aSelector onError: eventHandler
self selector:aSelector onEvent:'error' do:eventHandler! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 8/16/2013 09:44'!
selector:aSelector onEvent:jqueryEvent do:eventlyEvent
eventlyEvent isArray ifTrue:[triggers addAll: eventlyEvent ]
	ifFalse:[self addTriggersFromJSCode:eventlyEvent].
^	(self selector:aSelector) onEvent:jqueryEvent do:eventlyEvent ! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:17'!
selector:aSelector onFocus: eventHandler
self selector:aSelector onEvent:'focus' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:18'!
selector:aSelector onFocusIn: eventHandler
self selector:aSelector onEvent:'focusin' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onFocusOut: eventHandler
self selector:aSelector onEvent:'focusout' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:22'!
selector:aSelector onHover: eventHandler
self selector:aSelector onEvent:'hover' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onKeyDown: eventHandler
self selector:aSelector onEvent:'keydown' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onKeyPress: eventHandler
self selector:aSelector onEvent:'keypress' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:20'!
selector:aSelector onKeyUp: eventHandler
self selector:aSelector onEvent:'keyup' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onLoad: eventHandler
self selector:aSelector  onEvent:'load' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseDown: eventHandler
self selector:aSelector onEvent:'mousedown' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseEnter: eventHandler
self selector:aSelector onEvent:'mouseenter' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseLeave: eventHandler
self selector:aSelector onEvent:'mouseleave' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseMove: eventHandler
self selector:aSelector onEvent:'mousemove' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseOut: eventHandler
self selector:aSelector onEvent:'mouseout' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseOver: eventHandler
self selector:aSelector onEvent:'mouseover' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:24'!
selector:aSelector onMouseUp: eventHandler
self selector:aSelector onEvent:'mouseup' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onReady: eventHandler
self selector:aSelector onEvent:'ready' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:13'!
selector:aSelector onResize: eventHandler
self selector:aSelector  onEvent:'resize' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:14'!
selector:aSelector onScroll: eventHandler
self selector:aSelector onEvent:'scroll' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:17'!
selector:aSelector onSelect: eventHandler
self selector:aSelector  onEvent:'select' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector:aSelector onSubmit: eventHandler
self selector:aSelector  onEvent:'submit' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onUnload: eventHandler
self selector:aSelector onEvent:'unload' do:eventHandler! !

!SCEvently methodsFor: 'private' stamp: 'JesusMari 9/1/2012 12:40'!
selectors
^self at:'selectors' ifAbsent:[self at:'selectors' put:(JsonObject new)].! !

!SCEvently methodsFor: 'protected' stamp: 'JesusMari 8/15/2013 13:48'!
triggering
|oc|
oc:=OrderedCollection new.
oc addAll: self triggers.
self values do:[:anEvenlyObject|
	(anEvenlyObject isKindOf:SCEvently) ifTrue: 
		[oc addAll: anEvenlyObject triggering]].
^oc asArray! !

!SCEvently methodsFor: 'private' stamp: 'JesusMari 8/15/2013 13:41'!
triggers
^triggers ! !

JsonObject subclass: #SCEventlyQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/17/2012 00:08'!
descending: aBoolean
self at:'descending' put:aBoolean! !

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:52'!
limit: anInteger
self at:'limit' put: anInteger! !

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:51'!
view: aViewName
self at:'view' put:aViewName! !

JsonObject subclass: #SCEventlySelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!SCEventlySelector methodsFor: 'accessing' stamp: 'JesusMari 9/4/2012 17:35'!
onEvent:event  do:jscriptFunction

self at:event put: jscriptFunction.
		! !
